 SliderSetting = {
   ["GridCliqueIt_ConfigPageGeneralEditPetScaleLow"] = 10,
   ["GridCliqueIt_ConfigPageGeneralEditPetScaleHigh"] = 100,

   ["GridCliqueIt_ConfigPageGeneralEditAScaleLow"] = 10,
   ["GridCliqueIt_ConfigPageGeneralEditAScaleHigh"] = 500,

   ["GridCliqueIt_ConfigPageGeneralEditAlphaLow"] = 0,
   ["GridCliqueIt_ConfigPageGeneralEditAlphaHigh"] = 100,

   ["GridCliqueIt_ConfigPageBarsEditManaLow"] = 0,
   ["GridCliqueIt_ConfigPageBarsEditManaHigh"] = 20,

   ["GridCliqueIt_ConfigPageGeneralEditIconLow"] = 0,
   ["GridCliqueIt_ConfigPageGeneralEditIconHigh"] = 100,

   ["GridCliqueIt_ConfigPageNamesEditNSizeLow"] = 10,
   ["GridCliqueIt_ConfigPageNamesEditNSizeHigh"] = 300,

   ["GridCliqueIt_ConfigPageNamesEditNLengthLow"] = 1,
   ["GridCliqueIt_ConfigPageNamesEditNLengthHigh"] = 16,

   ["GridCliqueIt_ConfigPageTextsEditDScaleLow"] = 10,
   ["GridCliqueIt_ConfigPageTextsEditDScaleHigh"] = 300,

   ["GridCliqueIt_ConfigPageTextsEditHScaleLow"] = 10,
   ["GridCliqueIt_ConfigPageTextsEditHScaleHigh"] = 300,

   ["GridCliqueIt_ConfigPageBarsEditXLow"] = 3,
   ["GridCliqueIt_ConfigPageBarsEditXHigh"] = 500,

   ["GridCliqueIt_ConfigPageBarsEditYLow"] = 3,
   ["GridCliqueIt_ConfigPageBarsEditYHigh"] = 500,

   ["GridCliqueIt_ConfigPageBarsEditSpacingLow"] = 0,
   ["GridCliqueIt_ConfigPageBarsEditSpacingHigh"] = 100
}

function GridCliqueIt_SaveConfig() 
   if (GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton1:IsChecked()) then 
      local old = GridCliqueIt_Settings_Temp["percharacter"]
      GridCliqueIt_Settings_Temp["percharacter"] = "true"
      GridCliqueIt_SaveSettingsValue("percharacter", "true") 
      GridCliqueIt_Settings_Temp["percharacter"] = old
   elseif (GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton2:IsChecked()) then 
      if (GridCliqueIt_Settings_Temp[UnitName("player")] and GridCliqueIt_Settings_Temp[UnitName("player")]["percharacter"]) then
	 GridCliqueIt_Settings_Temp[UnitName("player")]["percharacter"] = "false"
      else
	 GridCliqueIt_Settings_Temp["percharacter"] = "false"
      end
   end

   GridCliqueIt_SaveSettingsValue("bheight",GridCliqueIt_ConfigPageBarsEditY:GetValue())
   GridCliqueIt_SaveSettingsValue("bwidth", GridCliqueIt_ConfigPageBarsEditX:GetValue()) 
   GridCliqueIt_SaveSettingsValue("nlength", GridCliqueIt_ConfigPageNamesEditNLength:GetValue()) 
   GridCliqueIt_SaveSettingsValue("spacing", tonumber(GridCliqueIt_ConfigPageBarsEditSpacing:GetValue())) 
   GridCliqueIt_SaveSettingsValue("nsize", tonumber(GridCliqueIt_ConfigPageNamesEditNSize:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("dsize", tonumber(GridCliqueIt_ConfigPageTextsEditDScale:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("hsize", tonumber(GridCliqueIt_ConfigPageTextsEditHScale:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("asize", tonumber(GridCliqueIt_ConfigPageGeneralEditAScale:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("petScale", tonumber(GridCliqueIt_ConfigPageGeneralEditPetScale:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("alpha", tonumber(GridCliqueIt_ConfigPageGeneralEditAlpha:GetValue()) / 100.0) 
   GridCliqueIt_SaveSettingsValue("ManaWidth", tonumber(GridCliqueIt_ConfigPageBarsEditMana:GetValue())) 
   GridCliqueIt_SaveSettingsValue("IconSize", tonumber(GridCliqueIt_ConfigPageGeneralEditIcon:GetValue())) 

   for i = 1,8 do
      GridCliqueIt_SaveSettingsValue("spell"..i, _G["GridCliqueIt_ConfigPageSpellsSpell"..i]:GetText()) 
   end

   for i = 1,8 do
      GridCliqueIt_SaveSettingsValue("spell2"..i, _G["GridCliqueIt_ConfigPageSpells2Spell"..i]:GetText()) 
   end

   if (GridCliqueIt_ConfigPageBarsCheckFillButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("fill","hor") 
   elseif (GridCliqueIt_ConfigPageBarsCheckFillButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("fill", "ver") 
   end 

   if (GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("manaOnlyPlayer", "Enable") 
   elseif (GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("manaOnlyPlayer", "Disable") 
   end 

   if (GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("playerpos", "TOPLEFT") 
   elseif (GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("playerpos", "TOPRIGHT") 
   elseif (GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("playerpos", "BOTTOMLEFT") 
   elseif (GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton4:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("playerpos","BOTTOMRIGHT") 
   end 

   if (GridCliqueIt_ConfigPageTextsCheckDruidHoTButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("DruidHoT", "Disable") 
   elseif (GridCliqueIt_ConfigPageTextsCheckDruidHoTButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("DruidHoT", "Recover") 
   elseif (GridCliqueIt_ConfigPageTextsCheckDruidHoTButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("DruidHoT", "Blossoming Life") 
   elseif (GridCliqueIt_ConfigPageTextsCheckDruidHoTButton4:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("DruidHoT","Both") 
   end 
  
   if (GridCliqueIt_ConfigPageBarsCheckAddMemberButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("rotation", "hor") 
   elseif (GridCliqueIt_ConfigPageBarsCheckAddMemberButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("rotation", "ver") 
   end 
   
   if (GridCliqueIt_ConfigPageNamesCheckNameColorButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ColorScheme", "RoM") 
   elseif (GridCliqueIt_ConfigPageNamesCheckNameColorButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ColorScheme",  "WoW") 
   elseif (GridCliqueIt_ConfigPageNamesCheckNameColorButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ColorScheme",  "White") 
   end 
   
   if (GridCliqueIt_ConfigPageNamesCheckLevelButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("showclass", "Disable") 
   elseif (GridCliqueIt_ConfigPageNamesCheckLevelButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("showclass",  "Short") 
   elseif (GridCliqueIt_ConfigPageNamesCheckLevelButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("showclass",  "Full") 
   end 

   if (GridCliqueIt_ConfigPageGeneralCheckToolTipButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("toolTip", "Enable") 
   elseif (GridCliqueIt_ConfigPageGeneralCheckToolTipButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("toolTip",  "Alt") 
   elseif (GridCliqueIt_ConfigPageGeneralCheckToolTipButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("toolTip",  "Disable") 
   end 

   if (GridCliqueIt_ConfigPageNamesCheckLeaderButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowLeader", "Disable") 
   elseif (GridCliqueIt_ConfigPageNamesCheckLeaderButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowLeader",  "Raid") 
   elseif (GridCliqueIt_ConfigPageNamesCheckLeaderButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowLeader",  "Party") 
   end 
   
   if (GridCliqueIt_ConfigPageBarsCheckBarColorButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("barstyle", "default") 
   elseif (GridCliqueIt_ConfigPageBarsCheckBarColorButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("barstyle",  "class") 
   elseif (GridCliqueIt_ConfigPageBarsCheckBarColorButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("barstyle",  "WoW") 
   end 

   if (GridCliqueIt_ConfigPageBarsCheckBarColorButton4:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("barcolorscheme", "RoM") 
   elseif (GridCliqueIt_ConfigPageBarsCheckBarColorButton5:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("barcolorscheme",  "WoW") 
   end 
      
   if (GridCliqueIt_ConfigPageBarsCheckSortByClassButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("SortByClass", "Disable") 
   elseif (GridCliqueIt_ConfigPageBarsCheckSortByClassButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("SortByClass",  "Ascending") 
   elseif (GridCliqueIt_ConfigPageBarsCheckSortByClassButton3:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("SortByClass",  "Descending") 
   end 

   if (GridCliqueIt_ConfigPageGeneralCheckBarsButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("enabled", "true") 
      GridCliqueIt_Loader:Show() 
      GridCliqueIt_main:Show() 
      GridCliqueIt_Anchor:Show() 
   elseif (GridCliqueIt_ConfigPageGeneralCheckBarsButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("enabled", "false") 
      GridCliqueIt_Loader:Hide() 
      GridCliqueIt_main:Hide() 
      GridCliqueIt_Anchor:Hide() 
   end 

   if (GridCliqueIt_ConfigPageGeneralCheckSoloButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowWhenSolo", "true") 
   elseif (GridCliqueIt_ConfigPageGeneralCheckSoloButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowWhenSolo", "false") 
   end 
   
  if (GridCliqueIt_ConfigPageGeneralCheckPetsButton1:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowPets", "true") 
   elseif (GridCliqueIt_ConfigPageGeneralCheckPetsButton2:IsChecked()) then 
      GridCliqueIt_SaveSettingsValue("ShowPets", "false") 
   end 

   local AnchorIds = {} 
   AnchorIds[1] = "TOPLEFT" 
   AnchorIds[2] = "TOP" 
   AnchorIds[3] = "TOPRIGHT" 
   AnchorIds[4] = "LEFT" 
   AnchorIds[5] = "CENTER" 
   AnchorIds[6] = "RIGHT" 
   AnchorIds[7] = "BOTTOMLEFT" 
   AnchorIds[8] = "BOTTOM" 
   AnchorIds[9] = "BOTTOMRIGHT" 
   AnchorIds[10] = "Disable" 
   
   for i = 1, 10 do 
      local fname = "GridCliqueIt_ConfigPageNamesCheckNameAnchorButton"..i 
      if (_G[fname]:IsChecked()) then 
	 GridCliqueIt_SaveSettingsValue("NAnchor", AnchorIds[i])
      end 
   end 
   for i = 1, 10 do 
      local fname = "GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButton"..i 
      if (_G[fname]:IsChecked()) then 
	 GridCliqueIt_SaveSettingsValue("DAnchor", AnchorIds[i]) 
      end 
   end 
   for i = 1, 10 do 
      local fname = "GridCliqueIt_ConfigPageTextsCheckHoTAnchorButton"..i 
      if (_G[fname]:IsChecked()) then 
	 GridCliqueIt_SaveSettingsValue("HAnchor", AnchorIds[i]) 
      end 
   end 

   partyHealth = {} 
   partyTimeBuffFlash = {} 
   myRegenerateTimes = {} 
   myRecoverTimes = {}

   GridCliqueIt_SavePosition()

   GridCliqueIt_UpDateFrames() 
   GridCliqueIt_ShowBar("saveconfig") 

end 

function GridCliqueIt_GetSettingsValue(key)
   local percharacter
   
   if (GridCliqueIt_Settings_Temp[UnitName("player")] and GridCliqueIt_Settings_Temp[UnitName("player")]["percharacter"]) then
      percharacter = GridCliqueIt_Settings_Temp[UnitName("player")]["percharacter"]
   else
      percharacter = GridCliqueIt_Settings_Temp["percharacter"]
   end
      
   if (percharacter=="true") then
      if (GridCliqueIt_Settings_Temp[UnitName("player")] and GridCliqueIt_Settings_Temp[UnitName("player")][key]) then 
	 return GridCliqueIt_Settings_Temp[UnitName("player")][key]
      else
	 if (GridCliqueIt_Settings_Temp[key]) then 
	    return GridCliqueIt_Settings_Temp[key] 
	 else 
	    return "" 
	 end 
      end
   else
      if (GridCliqueIt_Settings_Temp[key]) then 
	 return GridCliqueIt_Settings_Temp[key] 
      else 
	 return "" 
      end 
   end 
end

function GridCliqueIt_SaveSettingsValue(key,value)
   if (GridCliqueIt_GetSettingsValue("percharacter")=="true") then
      if (GridCliqueIt_Settings_Temp[UnitName("player")]) then
	 GridCliqueIt_Settings_Temp[UnitName("player")][key] = value
      else
	 GridCliqueIt_Settings_Temp[UnitName("player")] = {[key] = value}
      end
   else
      GridCliqueIt_Settings_Temp[key] = value
   end 
end

function GridCliqueIt_Copy(settingslist)
   local c1 = {}
   for k,v in pairs(settingslist) do
      c1[k] = v
   end
   return c1
end

function GridCliqueIt_Tabs(thisItem)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonGeneral, false)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonSpells, false)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonSpells2, false)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonNames, false)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonTexts, false)
   UIPanelTab_SetActiveState(GridCliqueIt_ConfigButtonBars, false)
   
   GridCliqueIt_ConfigPageGeneral:Hide()
   GridCliqueIt_ConfigPageSpells:Hide()
   GridCliqueIt_ConfigPageSpells2:Hide()
   GridCliqueIt_ConfigPageNames:Hide()
   GridCliqueIt_ConfigPageTexts:Hide()
   GridCliqueIt_ConfigPageBars:Hide()

   UIPanelTab_SetActiveState(thisItem, true)
   thisItem:Show()
end

function GridCliqueIt_CancelButtonClick()
   GridCliqueIt_Settings_Temp = GridCliqueIt_Copy(GridCliqueIt_Settings)
   GridCliqueIt_UpDateFrames()
   GridCliqueIt_ShowBar()
   GridCliqueIt_Config:Hide()
   GridCliqueIt_Anchor:Hide()
end

function GridCliqueIt_SaveButtonClick()
   GridCliqueIt_SaveConfig() 
   if (GridCliqueIt_GetSettingsValue("percharacter")=="true") then
      GridCliqueIt_Settings[UnitName("player")] = GridCliqueIt_Copy(GridCliqueIt_Settings_Temp[UnitName("player")])
      Sol.config.SaveConfig("GridCliqueIt")
      Sol.io.Print("Settings saved for character: "..UnitName("player")..".")
   else
      GridCliqueIt_Settings = GridCliqueIt_Copy(GridCliqueIt_Settings_Temp)
      Sol.config.SaveConfig("GridCliqueIt")
      Sol.io.Print("Settings saved globally.")
   end
   GridCliqueIt_Config:Hide()
   GridCliqueIt_Anchor:Hide()
end
	    
function GridCliqueIt_ShowConfig() 
   if (GridCliqueIt_Config:IsVisible()) then 
      GridCliqueIt_Config:Hide() 
      GridCliqueIt_Anchor:Hide() 
   else 
      GridCliqueIt_Config:Show() 
      GridCliqueIt_Anchor:Show() 
      GridCliqueIt_ConfigCheckLoad()
   end 
end 

function GridCliqueIt_ConfigCheckLoad()
   GridCliqueIt_ConfigPageBarsEditX:SetValue(GridCliqueIt_GetSettingsValue("bwidth")) 
   GridCliqueIt_ConfigPageBarsEditY:SetValue(GridCliqueIt_GetSettingsValue("bheight")) 
   GridCliqueIt_ConfigPageTextsEditDScale:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("dsize"))) 
   GridCliqueIt_ConfigPageTextsEditHScale:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("hsize"))) 
   GridCliqueIt_ConfigPageBarsEditSpacing:SetValue(GridCliqueIt_GetSettingsValue("spacing")) 
   GridCliqueIt_ConfigPageGeneralEditAScale:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("asize")))    
   GridCliqueIt_ConfigPageGeneralEditPetScale:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("petScale")))    
   GridCliqueIt_ConfigPageGeneralEditAlpha:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("alpha")))    
   GridCliqueIt_ConfigPageBarsEditMana:SetValue(tonumber(GridCliqueIt_GetSettingsValue("ManaWidth")))    
   GridCliqueIt_ConfigPageGeneralEditIcon:SetValue(tonumber(GridCliqueIt_GetSettingsValue("IconSize")))    
   GridCliqueIt_ConfigPageNamesEditNSize:SetValue(100*tonumber(GridCliqueIt_GetSettingsValue("nsize"))) 
   GridCliqueIt_ConfigPageNamesEditNLength:SetValue(GridCliqueIt_GetSettingsValue("nlength"))

   for i = 1,8 do
      _G["GridCliqueIt_ConfigPageSpellsSpell"..i]:SetText(GridCliqueIt_GetSettingsValue("spell"..i)) 
   end

   for i = 1,8 do
      _G["GridCliqueIt_ConfigPageSpells2Spell"..i]:SetText(GridCliqueIt_GetSettingsValue("spell2"..i)) 
   end

   local AnchorIds = {} 
   AnchorIds[1] = "TOPLEFT" 
   AnchorIds[2] = "TOP" 
   AnchorIds[3] = "TOPRIGHT" 
   AnchorIds[4] = "LEFT" 
   AnchorIds[5] = "CENTER" 
   AnchorIds[6] = "RIGHT" 
   AnchorIds[7] = "BOTTOMLEFT" 
   AnchorIds[8] = "BOTTOM" 
   AnchorIds[9] = "BOTTOMRIGHT" 
   AnchorIds[10] = "Disable" 
   
   for i = 1,10 do 
      if (GridCliqueIt_GetSettingsValue("NAnchor") == AnchorIds[i]) then 
	 _G["GridCliqueIt_ConfigPageNamesCheckNameAnchorButton"..i]:SetChecked(true)
      end 
   end 
   
   for i = 1,10 do 
      if (GridCliqueIt_GetSettingsValue("DAnchor") ==  AnchorIds[i]) then 
	 _G["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButton"..i]:SetChecked(true)
      end 
   end 
   
   for i = 1,10 do 
      if (GridCliqueIt_GetSettingsValue("HAnchor") ==  AnchorIds[i]) then 
	 _G["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButton"..i]:SetChecked(true)
      end 
   end 
   
   if (GridCliqueIt_GetSettingsValue("playerpos")=="TOPLEFT") then 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton4:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("playerpos")=="TOPRIGHT") then 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton4:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("playerpos")=="BOTTOMLEFT") then 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton3:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton4:SetChecked(false)
   elseif (GridCliqueIt_GetSettingsValue("playerpos")=="BOTTOMRIGHT") then 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButton4:SetChecked(true)  
   end 

   if (GridCliqueIt_GetSettingsValue("DruidHoT")=="Disable") then 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton4:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("DruidHoT")=="Recover") then 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton4:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("DruidHoT")=="Blossoming Life") then 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton3:SetChecked(true) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton4:SetChecked(false)
   elseif (GridCliqueIt_GetSettingsValue("DruidHoT")=="Both") then 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageTextsCheckDruidHoTButton4:SetChecked(true)  
   end 

   if (GridCliqueIt_GetSettingsValue("fill")=="hor") then 
      GridCliqueIt_ConfigPageBarsCheckFillButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckFillButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageBarsCheckFillButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckFillButton1:SetChecked(false) 
   end 

   if (GridCliqueIt_GetSettingsValue("manaOnlyPlayer")=="Enable") then 
      GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButton1:SetChecked(false) 
   end 
   
   if (GridCliqueIt_GetSettingsValue("rotation")=="hor") then 
      GridCliqueIt_ConfigPageBarsCheckAddMemberButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckAddMemberButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageBarsCheckAddMemberButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckAddMemberButton1:SetChecked(false) 
   end 
   
   if (GridCliqueIt_GetSettingsValue("enabled")=="true") then 
      GridCliqueIt_ConfigPageGeneralCheckBarsButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckBarsButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageGeneralCheckBarsButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckBarsButton2:SetChecked(false) 
   end 

   if (GridCliqueIt_GetSettingsValue("ShowWhenSolo")=="true") then 
      GridCliqueIt_ConfigPageGeneralCheckSoloButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckSoloButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageGeneralCheckSoloButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckSoloButton1:SetChecked(false) 
   end 

   if (GridCliqueIt_GetSettingsValue("ShowPets")=="true") then 
      GridCliqueIt_ConfigPageGeneralCheckPetsButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckPetsButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageGeneralCheckPetsButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckPetsButton1:SetChecked(false) 
   end 

   if (GridCliqueIt_GetSettingsValue("percharacter")=="true") then 
      GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton2:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckPerCharacterButton1:SetChecked(false) 
   end 
   
   if (GridCliqueIt_GetSettingsValue("barstyle")=="default") then 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton3:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton4:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton5:SetChecked(false)
   elseif (GridCliqueIt_GetSettingsValue("barstyle")=="class") then 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton3:SetChecked(false)
      if (GridCliqueIt_GetSettingsValue("barcolorscheme")=="RoM") then 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton4:SetChecked(true) 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton5:SetChecked(false)
      elseif (GridCliqueIt_GetSettingsValue("barcolorscheme")=="WoW") then 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton4:SetChecked(false) 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton5:SetChecked(true)
      end
   else
      GridCliqueIt_ConfigPageBarsCheckBarColorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckBarColorButton3:SetChecked(true)
      if (GridCliqueIt_GetSettingsValue("barcolorscheme")=="RoM") then 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton4:SetChecked(true) 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton5:SetChecked(false)
      elseif (GridCliqueIt_GetSettingsValue("barcolorscheme")=="WoW") then 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton4:SetChecked(false) 
	 GridCliqueIt_ConfigPageBarsCheckBarColorButton5:SetChecked(true)
      end
   end

   if (GridCliqueIt_GetSettingsValue("ColorScheme")=="RoM") then 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton3:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("ColorScheme")=="WoW") then 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton3:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckNameColorButton3:SetChecked(true) 
   end 

   if (GridCliqueIt_GetSettingsValue("showclass")=="Disable") then 
      GridCliqueIt_ConfigPageNamesCheckLevelButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton3:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("showclass")=="Short") then 
      GridCliqueIt_ConfigPageNamesCheckLevelButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton3:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageNamesCheckLevelButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLevelButton3:SetChecked(true) 
   end 

   if (GridCliqueIt_GetSettingsValue("toolTip")=="Enable") then 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton3:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("toolTip")=="Alt") then 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton3:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageGeneralCheckToolTipButton3:SetChecked(true) 
   end 

   if (GridCliqueIt_GetSettingsValue("SortByClass")=="Disable") then 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton3:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("SortByClass")=="Ascending") then 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton3:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageBarsCheckSortByClassButton3:SetChecked(true) 
   end 

   if (GridCliqueIt_GetSettingsValue("ShowLeader")=="Disable") then 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton1:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton3:SetChecked(false) 
   elseif (GridCliqueIt_GetSettingsValue("ShowLeader")=="Raid") then 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton2:SetChecked(true) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton3:SetChecked(false) 
   else 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton1:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton2:SetChecked(false) 
      GridCliqueIt_ConfigPageNamesCheckLeaderButton3:SetChecked(true) 
   end 
end 

function GridCliqueIt_CheckButtonFunction(frame, number, numberofbuttons) 
   for i = 1, numberofbuttons do
      _G[frame .. i]:SetChecked(false) 
   end
   _G[frame .. number]:SetChecked(true) 
   GridCliqueIt_SaveConfig() 
end

function GridCliqueIt_CheckBarColor(frame) 
   if (frame == "GridCliqueIt_ConfigPageBarsCheckBarColorButton1") then
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton1"
      _G[fname]:SetChecked(true) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton2" 
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton3" 
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton4" 
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton5" 
      _G[fname]:SetChecked(false)
   elseif (frame == "GridCliqueIt_ConfigPageBarsCheckBarColorButton2") then
       local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton1"
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton2" 
      _G[fname]:SetChecked(true) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton3" 
      _G[fname]:SetChecked(false) 
      if (not GridCliqueIt_ConfigPageBarsCheckBarColorButton4:IsChecked()) and (not GridCliqueIt_ConfigPageBarsCheckBarColorButton5:IsChecked()) then
	 local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton4" 
	 _G[fname]:SetChecked(true) 
	 local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton5" 
	 _G[fname]:SetChecked(false) 
      end
   elseif (frame == "GridCliqueIt_ConfigPageBarsCheckBarColorButton3") then
       local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton1"
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton2" 
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton3" 
      _G[fname]:SetChecked(true) 
      if (not GridCliqueIt_ConfigPageBarsCheckBarColorButton4:IsChecked()) and (not GridCliqueIt_ConfigPageBarsCheckBarColorButton5:IsChecked()) then
	 local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton4" 
	 _G[fname]:SetChecked(true) 
	 local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton5" 
	 _G[fname]:SetChecked(false) 
      end
   elseif (frame == "GridCliqueIt_ConfigPageBarsCheckBarColorButton4") then
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton4" 
      _G[fname]:SetChecked(true) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton5" 
      _G[fname]:SetChecked(false) 
   elseif (frame == "GridCliqueIt_ConfigPageBarsCheckBarColorButton5") then
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton4" 
      _G[fname]:SetChecked(false) 
      local fname = "GridCliqueIt_ConfigPageBarsCheckBarColorButton5" 
      _G[fname]:SetChecked(true) 
   end

   GridCliqueIt_SaveConfig() 
end 

function GridCliqueIt_SaveSlider(name, value)
   if (GridCliqueIt_VarsLoaded == true) then
      if (name == "GridCliqueIt_ConfigPageGeneralEditAScale") then
	 GridCliqueIt_SaveSettingsValue("asize", tonumber(value) / 100.0)    
	 GridCliqueIt_UpDateFrames()
      elseif (name == "GridCliqueIt_ConfigPageGeneralEditAlpha") then
	 GridCliqueIt_SaveSettingsValue("alpha", tonumber(value) / 100.0)    
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageGeneralEditPetScale") then
	 GridCliqueIt_SaveSettingsValue("petScale", tonumber(value) / 100.0)    
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageBarsEditMana") then
	 GridCliqueIt_SaveSettingsValue("ManaWidth", tonumber(value))    
	 GridCliqueIt_UpDateFrames()
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageGeneralEditIcon") then
	 GridCliqueIt_SaveSettingsValue("IconSize", tonumber(value))    
	 GridCliqueIt_UpDateFrames()
      elseif (name == "GridCliqueIt_ConfigPageNamesEditNSize") then
	 GridCliqueIt_SaveSettingsValue("nsize", tonumber(value) / 100.0) 
	 GridCliqueIt_UpDateFrames()
      elseif (name == "GridCliqueIt_ConfigPageNamesEditNLength") then
	 GridCliqueIt_SaveSettingsValue("nlength", GridCliqueIt_ConfigPageNamesEditNLength:GetValue()) 
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageTextsEditDScale") then
	 GridCliqueIt_SaveSettingsValue("dsize", tonumber(value) / 100.0) 
	 GridCliqueIt_UpDateFrames()
      elseif (name == "GridCliqueIt_ConfigPageTextsEditHScale") then
	 GridCliqueIt_SaveSettingsValue("hsize", tonumber(value) / 100.0) 
	 GridCliqueIt_UpDateFrames()
      elseif (name == "GridCliqueIt_ConfigPageBarsEditX") then
	 GridCliqueIt_SaveSettingsValue("bwidth", value) 
	 GridCliqueIt_UpDateFrames()
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageBarsEditY") then
	 GridCliqueIt_SaveSettingsValue("bheight", value) 
	 GridCliqueIt_UpDateFrames()
	 GridCliqueIt_ShowBar()
      elseif (name == "GridCliqueIt_ConfigPageBarsEditSpacing") then
	 GridCliqueIt_SaveSettingsValue("spacing", value) 
	 GridCliqueIt_UpDateFrames()
	 GridCliqueIt_ShowBar()
      end
   end
end
