--[[Strings
--]]

ConfigTexts = {
   ["GridCliqueIt_ConfigPageSpellsSpell1Text"] = {
      ["EN"] = "Spell to be Cast on Left Click",
      ["DE"] = "Zauber bei Linksklick",
      ["FR"] = "Spell to be Cast on Left Click",
      ["ES"] = "Spell to be Cast on Left Click",
      ["RU"] = "Spell to be Cast on Left Click",
      ["KR"] = "왼쪽 클릭시 시전할 스킬",
      ["JP"] = "左クリックで詠唱するスキル",
      ["TW"] = "點擊滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell2Text"] = {
      ["EN"] = "Spell to be Cast on Right Click",     
      ["DE"] = "Zauber bei Rechtsklick",
      ["FR"] = "Spell to be Cast on Right Click",
      ["ES"] = "Spell to be Cast on Right Click",
      ["RU"] = "Spell to be Cast on Right Click",
      ["KR"] = "오른쪽 클릭시 시전할 스킬",
      ["JP"] = "右クリックで詠唱するスキル",
      ["TW"] = "點擊滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell3Text"] = {
      ["EN"] = "Spell to be Cast on Shift+Left Click",      
      ["DE"] = "Zauber bei Shift + Linksklick",
      ["FR"] = "Spell to be Cast on Shift+Left Click",
      ["ES"] = "Spell to be Cast on Shift+Left Click",
      ["RU"] = "Spell to be Cast on Shift+Left Click",
      ["KR"] = "Shift + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+左クリックで詠唱するスキル",
      ["TW"] = "Shift + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell4Text"] = {
      ["EN"] = "Spell to be Cast on Shift+Right Click",
      ["DE"] = "Zauber bei Shift + Rechtsklick",
      ["FR"] = "Spell to be Cast on Shift+Right Click",
      ["ES"] = "Spell to be Cast on Shift+Right Click",
      ["RU"] = "Spell to be Cast on Shift+Right Click",
      ["KR"] = "Shift + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+右クリックで詠唱するスキル",
      ["TW"] = "Shift + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell5Text"] = {
      ["EN"] = "Spell to be Cast on Ctrl+Left Click",	    
      ["DE"] = "Zauber bei Strg + Linksklick",
      ["FR"] = "Spell to be Cast on Ctrl+Left Click",
      ["ES"] = "Spell to be Cast on Ctrl+Left Click",
      ["RU"] = "Spell to be Cast on Ctrl+Left Click",
      ["KR"] = "Ctrl + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "CTRL+左クリックで詠唱するスキル",
      ["TW"] = "Ctrl + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell6Text"] = {
      ["EN"] = "Spell to be Cast on Ctrl+Right Click",
      ["DE"] = "Zauber bei Strg + Rechtsklick",
      ["FR"] = "Spell to be Cast on Ctrl+Right Click",
      ["ES"] = "Spell to be Cast on Ctrl+Right Click",
      ["RU"] = "Spell to be Cast on Ctrl+Right Click",
      ["KR"] = "Ctrl + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "CTRL+右クリックで詠唱するスキル",
      ["TW"] = "Ctrl + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell7Text"] = {
      ["EN"] = "Spell to be Cast on Alt+Left Click",
      ["DE"] = "Zauber bei Alt + Linksklick",
      ["FR"] = "Spell to be Cast on Alt+Left Click",
      ["ES"] = "Spell to be Cast on Alt+Left Click",
      ["RU"] = "Spell to be Cast on Alt+Left Click",
      ["KR"] = "Alt + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "ALT+左クリックで詠唱するスキル",
      ["TW"] = "Alt + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpellsSpell8Text"] = {
      ["EN"] = "Spell to be Cast on Alt+Right Click",
      ["DE"] = "Zauber bei Alt + Rechtsklick",
      ["FR"] = "Spell to be Cast on Alt+Right Click",
      ["ES"] = "Spell to be Cast on Alt+Right Click",
      ["RU"] = "Spell to be Cast on Alt+Right Click",
      ["KR"] = "Alt + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "ALT+右クリックで詠唱するスキル",
      ["TW"] = "Alt + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell1Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Ctrl + Left Click",
      ["DE"] = "Zauber bei Shift + Strg + Linksklick",
      ["FR"] = "Spell to be Cast on Shift + Ctrl + Left Click",
      ["ES"] = "Spell to be Cast on Shift + Ctrl + Left Click",
      ["RU"] = "Spell to be Cast on Shift + Ctrl + Left Click",
      ["KR"] = "Shift + Ctrl + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+CTRL+左クリックで詠唱するスキル",
      ["TW"] = "Shift + Ctrl + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell2Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Ctrl + Right Click",
      ["DE"] = "Zauber bei Shift + Strg + Rechtsklick",
      ["FR"] = "Spell to be Cast on Shift + Ctrl + Right Click",
      ["ES"] = "Spell to be Cast on Shift + Ctrl + Right Click",
      ["RU"] = "Spell to be Cast on Shift + Ctrl + Right Click",
      ["KR"] = "Shift + Ctrl + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+ALT+右クリックで詠唱するスキル",
      ["TW"] = "Shift + Ctrl + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell3Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Alt + Left Click",
      ["DE"] = "Zauber bei Shift + Alt + Linksklick",
      ["FR"] = "Spell to be Cast on Shift + Alt + Left Click",
      ["ES"] = "Spell to be Cast on Shift + Alt + Left Click",
      ["RU"] = "Spell to be Cast on Shift + Alt + Left Click",
      ["KR"] = "Shift + Alt + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+ALT+左クリックで詠唱するスキル",
      ["TW"] = "Shift + Alt + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell4Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Alt + Right Click",
      ["DE"] = "Zauber bei Shift + Alt + Rechtsklick",
      ["FR"] = "Spell to be Cast on Shift + Alt + Right Click",
      ["ES"] = "Spell to be Cast on Shift + Alt + Right Click",
      ["RU"] = "Spell to be Cast on Shift + Alt + Right Click",
      ["KR"] = "Shift + Alt + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+ALT+右クリックで詠唱するスキル",
      ["TW"] = "Shift + Alt + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell5Text"] = {
      ["EN"] = "Spell to be Cast on Ctrl + Alt + Left Click",
      ["DE"] = "Zauber bei Strg + Alt + Linksklick",
      ["FR"] = "Spell to be Cast on Ctrl + Alt + Left Click",
      ["ES"] = "Spell to be Cast on Ctrl + Alt + Left Click",
      ["RU"] = "Spell to be Cast on Ctrl + Alt + Left Click",
      ["KR"] = "Ctrl + Alt + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "CTRL+ALT+左クリックで詠唱するスキル",
      ["TW"] = "Ctrl + Alt + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell6Text"] = {
      ["EN"] = "Spell to be Cast on Ctrl + Alt + Right Click",
      ["DE"] = "Zauber bei Strg + Alt + Rechtsklick",
      ["FR"] = "Spell to be Cast on Ctrl + Alt + Right Click",
      ["ES"] = "Spell to be Cast on Ctrl + Alt + Right Click",
      ["RU"] = "Spell to be Cast on Ctrl + Alt + Right Click",
      ["KR"] = "Ctrl + Alt + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "CTRL+ALT+右クリックで詠唱するスキル",
      ["TW"] = "Ctrl + Alt + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell7Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Ctrl + Alt + Left Click",
      ["DE"] = "Zauber bei Shift + Strg + Alt + Linksklick",
      ["FR"] = "Spell to be Cast on Shift + Ctrl + Alt + Left Click",
      ["ES"] = "Spell to be Cast on Shift + Ctrl + Alt + Left Click",
      ["RU"] = "Spell to be Cast on Shift + Ctrl + Alt + Left Click",
      ["KR"] = "Shift + Ctrl + Alt + 왼쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+CTRL+ALT+左クリックで詠唱するスキル",
      ["TW"] = "Shift + Ctrl + Alt + 滑鼠左鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell8Text"] = {
      ["EN"] = "Spell to be Cast on Shift + Ctrl + Alt + Right Click",
      ["DE"] = "Zauber bei Shift + Strg + Alt + Rechtsklick",
      ["FR"] = "Spell to be Cast on Shift + Ctrl + Alt + Right Click",
      ["ES"] = "Spell to be Cast on Shift + Ctrl + Alt + Right Click",
      ["RU"] = "Spell to be Cast on Shift + Ctrl + Alt + Right Click",
      ["KR"] = "Shift + Ctrl + Alt + 오른쪽 클릭시 시전할 스킬",
      ["JP"] = "SHIFT+CTRL+ALT+右クリックで詠唱するスキル",
      ["TW"] = "Shift + Ctrl + Alt + 滑鼠右鍵施放技能"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell8TextExplain1"] = {
      ["EN"] = "'Target' and 'Dropdown Menu' are also valid spells.",
      ["DE"] = "'Target' und 'Dropdown Menu' sind ebenfalls g\195\188ltig.",
      ["FR"] = "'Target' and 'Dropdown Menu' are also valid spells.",
      ["ES"] = "'Target' and 'Dropdown Menu' are also valid spells.",
      ["RU"] = "'Target' and 'Dropdown Menu' are also valid spells.",
      ["KR"] = "'Target' 과 'Dropdown Menu' 같이 스킬명을 입력해서 사용가능",
      ["JP"] = "'Target'指定でターゲット、'Dropdown Menu'でメニュー表示",
      ["TW"] = "可輸入'Target'(目標)或'Dropdown Menu'(下拉選單)或技能名"
   },
  ["GridCliqueIt_ConfigPageSpells2Spell8TextExplain2"] = {
      ["EN"] = "Use numbers for Action Bar spells/items, note that",
      ["DE"] = "Benutze Nummern f\195\188r Aktionsleisten-Zauber/-Items",
      ["FR"] = "Use numbers for Action Bar spells/items, note that",
      ["ES"] = "Use numbers for Action Bar spells/items, note that",
      ["RU"] = "Use numbers for Action Bar spells/items, note that",
      ["KR"] = "액션바 슬롯의 스킬/아이템 사용",
      ["JP"] = "スキルはスロットNo、スキル名が使用できます",
      ["TW"] = "使用快捷列編號空格中的技能/物品"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell8TextExplain3"] = {
      ["EN"] = "using numbers will make you lose target",
      ["DE"] = "(1-20 Hauptaktionsleiste, 21-40 obere Aktionsleiste)",
      ["FR"] = "using numbers will make you lose target",
      ["ES"] = "using numbers will make you lose target",
      ["RU"] = "using numbers will make you lose target",
      ["KR"] = "(슬롯번호 : 메인 1~20, 상위 21~40, 오른쪽 41~60, 왼쪽 61~80)",
      ["JP"] = "(スロットNoメイン1-12,上21-32,右41-60,左61-80)",
      ["TW"] = "(快捷列編號:主1-20,上21-40,右41-60,左61-80)"
   },
   ["GridCliqueIt_ConfigPageSpells2Spell8TextExplain4"] = {
      ["EN"] = "(1-12 Main Action Bar, 21-32 Upper Action Bar)",
      ["DE"] = "",
      ["FR"] = "(1-12 Main Action Bar, 21-32 Upper Action Bar)",
      ["ES"] = "(1-12 Main Action Bar, 21-32 Upper Action Bar)",
      ["RU"] = "(1-12 Main Action Bar, 21-32 Upper Action Bar)",
      ["KR"] = "",
      ["JP"] = "",
      ["TW"] = ""
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextHead"] = {
      ["EN"] = "Select Anchor for Unit Names",
      ["DE"] = "Anordnung der Spielernamen",
      ["FR"] = "Select Anchor for Unit Names",
      ["ES"] = "Select Anchor for Unit Names",
      ["RU"] = "Select Anchor for Unit Names",
      ["KR"] = "캐릭명 표시 위치",
      ["JP"] = "キャラ名のアンカー表示位置",
      ["TW"] = "設定單位名稱位置"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton1"] = {
      ["EN"] = "TOPLEFT",
      ["DE"] = "Oben links",
      ["FR"] = "TOPLEFT",
      ["ES"] = "TOPLEFT",
      ["RU"] = "TOPLEFT",
      ["KR"] = "좌상",
      ["JP"] = "左上",
      ["TW"] = "左上"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton2"] = {
      ["EN"] = "TOP",
      ["DE"] = "Oben",
      ["FR"] = "TOP",
      ["ES"] = "TOP",
      ["RU"] = "TOP",
      ["KR"] = "상",
      ["JP"] = "上",
      ["TW"] = "上"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton3"] = {
      ["EN"] = "TOPRIGHT",
      ["DE"] = "Oben rechts",
      ["FR"] = "TOPRIGHT",
      ["ES"] = "TOPRIGHT",
      ["RU"] = "TOPRIGHT",
      ["KR"] = "우상",
      ["JP"] = "右上",
      ["TW"] = "右上"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton4"] = {
      ["EN"] = "LEFT",
      ["DE"] = "Links",
      ["FR"] = "LEFT",
      ["ES"] = "LEFT",
      ["RU"] = "LEFT",
      ["KR"] = "좌",
      ["JP"] = "左",
      ["TW"] = "左"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton5"] = {
      ["EN"] = "CENTER",
      ["DE"] = "Mitte",
      ["FR"] = "CENTER",
      ["ES"] = "CENTER",
      ["RU"] = "CENTER",
      ["KR"] = "중앙",
      ["JP"] = "中央",
      ["TW"] = "中"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton6"] = {
      ["EN"] = "RIGHT",
      ["DE"] = "Rechts",
      ["FR"] = "RIGHT",
      ["ES"] = "RIGHT",
      ["RU"] = "RIGHT",
      ["KR"] = "우",
      ["JP"] = "右",
      ["TW"] = "右"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton7"] = {
      ["EN"] = "BOTTOMLEFT",
      ["DE"] = "Unten links",
      ["FR"] = "BOTTOMLEFT",
      ["ES"] = "BOTTOMLEFT",
      ["RU"] = "BOTTOMLEFT",
      ["KR"] = "좌하",
      ["JP"] = "左下",
      ["TW"] = "左下"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton8"] = {
      ["EN"] = "BOTTOM",
      ["DE"] = "Unten",
      ["FR"] = "BOTTOM",
      ["ES"] = "BOTTOM",
      ["RU"] = "BOTTOM",
      ["KR"] = "하",
      ["JP"] = "下",
      ["TW"] = "下"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton9"] = {
      ["EN"] = "BOTTOMRIGHT",
      ["DE"] = "Unten rechts",
      ["FR"] = "BOTTOMRIGHT",
      ["ES"] = "BOTTOMRIGHT",
      ["RU"] = "BOTTOMRIGHT",
      ["KR"] = "우하",
      ["JP"] = "右下",
      ["TW"] = "右下"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameAnchorButtonTextButton10"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextHead"] = {
      ["EN"] = "Select Anchor for Health Deficit",
      ["DE"] = "Anordnung des Lebenspunkteverlustes",
      ["FR"] = "Select Anchor for Health Deficit",
      ["ES"] = "Select Anchor for Health Deficit",
      ["RU"] = "Select Anchor for Health Deficit",
      ["KR"] = "감소한 체력 표시 위치",
      ["JP"] = "被ダメージ表示位置",
      ["TW"] = "設定生命減損文字位置"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton1"] = {
      ["EN"] = "TOPLEFT",
      ["DE"] = "Oben links",
      ["FR"] = "TOPLEFT",
      ["ES"] = "TOPLEFT",
      ["RU"] = "TOPLEFT",
      ["KR"] = "좌상",
      ["JP"] = "左上",
      ["TW"] = "左上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton2"] = {
      ["EN"] = "TOP",
      ["DE"] = "Oben",
      ["FR"] = "TOP",
      ["ES"] = "TOP",
      ["RU"] = "TOP",
      ["KR"] = "상",
      ["JP"] = "上",
      ["TW"] = "上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton3"] = {
      ["EN"] = "TOPRIGHT",
      ["DE"] = "Oben rechts",
      ["FR"] = "TOPRIGHT",
      ["ES"] = "TOPRIGHT",
      ["RU"] = "TOPRIGHT",
      ["KR"] = "우상",
      ["JP"] = "右上",
      ["TW"] = "右上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton4"] = {
      ["EN"] = "LEFT",
      ["DE"] = "Links",
      ["FR"] = "LEFT",
      ["ES"] = "LEFT",
      ["RU"] = "LEFT",
      ["KR"] = "좌",
      ["JP"] = "左",
      ["TW"] = "左"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton5"] = {
      ["EN"] = "CENTER",
      ["DE"] = "Mitte",
      ["FR"] = "CENTER",
      ["ES"] = "CENTER",
      ["RU"] = "CENTER",
      ["KR"] = "중앙",
      ["JP"] = "中央",
      ["TW"] = "中"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton6"] = {
      ["EN"] = "RIGHT",
      ["DE"] = "Rechts",
      ["FR"] = "RIGHT",
      ["ES"] = "RIGHT",
      ["RU"] = "RIGHT",
      ["KR"] = "우",
      ["JP"] = "右",
      ["TW"] = "右"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton7"] = {
      ["EN"] = "BOTTOMLEFT",
      ["DE"] = "Unten links",
      ["FR"] = "BOTTOMLEFT",
      ["ES"] = "BOTTOMLEFT",
      ["RU"] = "BOTTOMLEFT",
      ["KR"] = "좌하",
      ["JP"] = "左下",
      ["TW"] = "左下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton8"] = {
      ["EN"] = "BOTTOM",
      ["DE"] = "Unten",
      ["FR"] = "BOTTOM",
      ["ES"] = "BOTTOM",
      ["RU"] = "BOTTOM",
      ["KR"] = "하",
      ["JP"] = "下",
      ["TW"] = "下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton9"] = {
      ["EN"] = "BOTTOMRIGHT",
      ["DE"] = "Unten rechts",
      ["FR"] = "BOTTOMRIGHT",
      ["ES"] = "BOTTOMRIGHT",
      ["RU"] = "BOTTOMRIGHT",
      ["KR"] = "우하",
      ["JP"] = "右下",
      ["TW"] = "右下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDeficitAnchorButtonTextButton10"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextHead"] = {
      ["EN"] = "Select Anchor for HoT Timer",
      ["DE"] = "Anordnung des HoT-Timers",
      ["FR"] = "Select Anchor for HoT Timer",
      ["ES"] = "Select Anchor for HoT Timer",
      ["RU"] = "Select Anchor for HoT Timer",
      ["KR"] = "도트힐 표시 위치",
      ["JP"] = "HoTタイマー表示位置",
      ["TW"] = "設定Hot計時位置"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton1"] = {
      ["EN"] = "TOPLEFT",
      ["DE"] = "Oben links",
      ["FR"] = "TOPLEFT",
      ["ES"] = "TOPLEFT",
      ["RU"] = "TOPLEFT",
      ["KR"] = "좌상",
      ["JP"] = "左上",
      ["TW"] = "左上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton2"] = {
      ["EN"] = "TOP",
      ["DE"] = "Oben",
      ["FR"] = "TOP",
      ["ES"] = "TOP",
      ["RU"] = "TOP",
      ["KR"] = "상",
      ["JP"] = "上",
      ["TW"] = "上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton3"] = {
      ["EN"] = "TOPRIGHT",
      ["DE"] = "Oben rechts",
      ["FR"] = "TOPRIGHT",
      ["ES"] = "TOPRIGHT",
      ["RU"] = "TOPRIGHT",
      ["KR"] = "우상",
      ["JP"] = "右上",
      ["TW"] = "右上"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton4"] = {
      ["EN"] = "LEFT",
      ["DE"] = "Links",
      ["FR"] = "LEFT",
      ["ES"] = "LEFT",
      ["RU"] = "LEFT",
      ["KR"] = "좌",
      ["JP"] = "左",
      ["TW"] = "左"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton5"] = {
      ["EN"] = "CENTER",
      ["DE"] = "Mitte",
      ["FR"] = "CENTER",
      ["ES"] = "CENTER",
      ["RU"] = "CENTER",
      ["KR"] = "중앙",
      ["JP"] = "中央",
      ["TW"] = "中"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton6"] = {
      ["EN"] = "RIGHT",
      ["DE"] = "Rechts",
      ["FR"] = "RIGHT",
      ["ES"] = "RIGHT",
      ["RU"] = "RIGHT",
      ["KR"] = "우",
      ["JP"] = "右",
      ["TW"] = "右"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton7"] = {
      ["EN"] = "BOTTOMLEFT",
      ["DE"] = "Unten links",
      ["FR"] = "BOTTOMLEFT",
      ["ES"] = "BOTTOMLEFT",
      ["RU"] = "BOTTOMLEFT",
      ["KR"] = "좌하",
      ["JP"] = "左下",
      ["TW"] = "左下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton8"] = {
      ["EN"] = "BOTTOM",
      ["DE"] = "Unten",
      ["FR"] = "BOTTOM",
      ["ES"] = "BOTTOM",
      ["RU"] = "BOTTOM",
      ["KR"] = "하",
      ["JP"] = "下",
      ["TW"] = "下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton9"] = {
      ["EN"] = "BOTTOMRIGHT",
      ["DE"] = "Unten rechts",
      ["FR"] = "BOTTOMRIGHT",
      ["ES"] = "BOTTOMRIGHT",
      ["RU"] = "BOTTOMRIGHT",
      ["KR"] = "우하",
      ["JP"] = "右下",
      ["TW"] = "右下"
   },
   ["GridCliqueIt_ConfigPageTextsCheckHoTAnchorButtonTextButton10"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButtonTextHead"] = {
      ["EN"] = "Player (Raid Member Nr. 1) Placement on the Grid",
      ["DE"] = "Platzierung des Spielers (Raidmitglied Nr. 1) im Raster",
      ["FR"] = "Player (Raid Member Nr. 1) Placement on the Grid",
      ["ES"] = "Player (Raid Member Nr. 1) Placement on the Grid",
      ["RU"] = "Player (Raid Member Nr. 1) Placement on the Grid",
      ["KR"] = "플레이어 (공격대원 1번) 그리드 위치",
      ["JP"] = "グリッド上のメンバー配置(レイドメンバーNo1)",
      ["TW"] = "玩家 (團隊成員Nr. 1) 在Grid中的位置設定"
   },
   ["GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButtonTextButton1"] = {
      ["EN"] = "TOPLEFT",
      ["DE"] = "Oben links",
      ["FR"] = "TOPLEFT",
      ["ES"] = "TOPLEFT",
      ["RU"] = "TOPLEFT",
      ["KR"] = "좌상",
      ["JP"] = "左上",
      ["TW"] = "左上"
   },
   ["GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButtonTextButton2"] = {
      ["EN"] = "TOPRIGHT",
      ["DE"] = "Oben rechts",
      ["FR"] = "TOPRIGHT",
      ["ES"] = "TOPRIGHT",
      ["RU"] = "TOPRIGHT",
      ["KR"] = "우상",
      ["JP"] = "右上",
      ["TW"] = "右上"
   },
   ["GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButtonTextButton3"] = {
      ["EN"] = "BOTTOMLEFT",
      ["DE"] = "Unten links",
      ["FR"] = "BOTTOMLEFT",
      ["ES"] = "BOTTOMLEFT",
      ["RU"] = "BOTTOMLEFT",
      ["KR"] = "좌하",
      ["JP"] = "左下",
      ["TW"] = "左下"
   },
   ["GridCliqueIt_ConfigPageBarsCheckPlayerAnchorButtonTextButton4"] = {
      ["EN"] = "BOTTOMRIGHT",
      ["DE"] = "Unten rechts",
      ["FR"] = "BOTTOMRIGHT",
      ["ES"] = "BOTTOMRIGHT",
      ["RU"] = "BOTTOMRIGHT",
      ["KR"] = "우하",
      ["JP"] = "右下",
      ["TW"] = "右下"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextHead"] = {
      ["EN"] = "Bar Color Style and Color Scheme",
      ["DE"] = "Farbstil und -schema der Balken",
      ["FR"] = "Bar Color Style and Color Scheme",
      ["ES"] = "Bar Color Style and Color Scheme",
      ["RU"] = "Bar Color Style and Color Scheme",
      ["KR"] = "바 스타일과 색상",
      ["JP"] = "バーの配色とカラースキーム",
      ["TW"] = "血條色彩風格以及色彩配置"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextButton1"] = {
      ["EN"] = "Default",
      ["DE"] = "Standard",
      ["FR"] = "Default",
      ["ES"] = "Default",
      ["RU"] = "Default",
      ["KR"] = "기본",
      ["JP"] = "標準",
      ["TW"] = "預設"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextButton2"] = {
      ["EN"] = "Class Colored",
      ["DE"] = "Klassenfarben",
      ["FR"] = "Class Colored",
      ["ES"] = "Class Colored",
      ["RU"] = "Class Colored",
      ["KR"] = "직업 색상",
      ["JP"] = "職別カラー",
      ["TW"] = "依職業著色"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextButton3"] = {
      ["EN"] = "WoW-style",
      ["DE"] = "WoW-Stil",
      ["FR"] = "WoW-style",
      ["ES"] = "WoW-style",
      ["RU"] = "WoW-style",
      ["KR"] = "WoW 스타일",
      ["JP"] = "WoWスタイル",
      ["TW"] = "WoW風格"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextButton4"] = {
      ["EN"] = "RoM-scheme",
      ["DE"] = "RoM-Schema",
      ["FR"] = "RoM-scheme",
      ["ES"] = "RoM-scheme",
      ["RU"] = "RoM-scheme",
      ["KR"] = "RoM 색상",
      ["JP"] = "RoMスタイル",
      ["TW"] = "RoM風格"
   },
   ["GridCliqueIt_ConfigPageBarsCheckBarColorButtonTextButton5"] = {
      ["EN"] = "WoW-scheme",
      ["DE"] = "Wow-Schema",
      ["FR"] = "WoW-scheme",
      ["ES"] = "WoW-scheme",
      ["RU"] = "WoW-scheme",
      ["KR"] = "WoW 색상",
      ["JP"] = "WoWスキーム",
      ["TW"] = "WoW配置"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLeaderButtonTextHead"] = {
      ["EN"] = "Mark Leader in",
      ["DE"] = "Anf\195\188hrer markieren",
      ["FR"] = "Mark Leader in",
      ["ES"] = "Mark Leader in",
      ["RU"] = "Mark Leader in",
      ["KR"] = "파티장 표시(*)",
      ["JP"] = "リーダーの表示",
      ["TW"] = "標記隊長"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLeaderButtonTextButton1"] = {
      ["EN"] = "Never",
      ["DE"] = "Niemals",
      ["FR"] = "Never",
      ["ES"] = "Never",
      ["RU"] = "Never",
      ["KR"] = "없음",
      ["JP"] = "非表示",
      ["TW"] = "從不"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLeaderButtonTextButton2"] = {
      ["EN"] = "Raid Only",
      ["DE"] = "Nur im Raid",
      ["FR"] = "Raid Only",
      ["ES"] = "Raid Only",
      ["RU"] = "Raid Only",
      ["KR"] = "공대에서만",
      ["JP"] = "レイドのみ",
      ["TW"] = "只在團隊"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLeaderButtonTextButton3"] = {
      ["EN"] = "Party and Raid",
      ["DE"] = "In Gruppe und Raid",
      ["FR"] = "Party and Raid",
      ["ES"] = "Party and Raid",
      ["RU"] = "Party and Raid",
      ["KR"] = "파티 및 공대 모두",
      ["JP"] = "PTとレイド",
      ["TW"] = "隊伍和團隊"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDruidHoTButtonTextHead"] = {
      ["EN"] = "Druid HoT Countdown",
      ["DE"] = "Druiden-HoT-Countdown",
      ["FR"] = "Druid HoT Countdown",
      ["ES"] = "Druid HoT Countdown",
      ["RU"] = "Druid HoT Countdown",
      ["KR"] = "드루이드 도트힐 표시",
      ["JP"] = "ドルイドのHoT表示",
      ["TW"] = "自然神官Hot倒數"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDruidHoTButtonTextButton1"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDruidHoTButtonTextButton2"] = {
      ["EN"] = "Recover",
      ["DE"] = "Erholung",
      ["FR"] = "Recover",
      ["ES"] = "Recover",
      ["RU"] = "Recover",
      ["KR"] = "상처 치유",
      ["JP"] = "リカバー",
      ["TW"] = "Recover"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDruidHoTButtonTextButton3"] = {
      ["EN"] = "Bloss. Life",
      ["DE"] = "Bl\195\188h. Leben",
      ["FR"] = "Bloss. Life",
      ["ES"] = "Bloss. Life",
      ["RU"] = "Bloss. Life",
      ["KR"] = "생명의 개화",
      ["JP"] = "ブロッサム",
      ["TW"] = "Bloss. Life"
   },
   ["GridCliqueIt_ConfigPageTextsCheckDruidHoTButtonTextButton4"] = {
      ["EN"] = "Both",
      ["DE"] = "Beide",
      ["FR"] = "Both",
      ["ES"] = "Both",
      ["RU"] = "Both",
      ["KR"] = "둘다",
      ["JP"] = "両方",
      ["TW"] = "兩者"
   },
   ["GridCliqueIt_ConfigPageBarsCheckSortByClassButtonTextHead"] = {
      ["EN"] = "Sort By Class",
      ["DE"] = "Nach Klassen sortieren",
      ["FR"] = "Sort By Class",
      ["ES"] = "Sort By Class",
      ["RU"] = "Sort By Class",
      ["KR"] = "직업별로 정렬",
      ["JP"] = "職別に並び替え",
      ["TW"] = "依照職業分類"
   },
   ["GridCliqueIt_ConfigPageBarsCheckSortByClassButtonTextButton1"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageBarsCheckSortByClassButtonTextButton2"] = {
      ["EN"] = "Ascending",
      ["DE"] = "Aufsteigend",
      ["FR"] = "Ascending",
      ["ES"] = "Ascending",
      ["RU"] = "Ascending",
      ["KR"] = "오름차순",
      ["JP"] = "昇順",
      ["TW"] = "升序"
   },
   ["GridCliqueIt_ConfigPageBarsCheckSortByClassButtonTextButton3"] = {
      ["EN"] = "Descending",
      ["DE"] = "Absteigend",
      ["FR"] = "Descending",
      ["ES"] = "Descending",
      ["RU"] = "Descending",
      ["KR"] = "내림차순",
      ["JP"] = "降順",
      ["TW"] = "降序"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLevelButtonTextHead"] = {
      ["EN"] = "Show Level and Class",
      ["DE"] = "Level und Klasse anzeigen",
      ["FR"] = "Show Level and Class",
      ["ES"] = "Show Level and Class",
      ["RU"] = "Show Level and Class",
      ["KR"] = "레벨과 직업 표시",
      ["JP"] = "Lvと職の表示",
      ["TW"] = "顯示等級和職業"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLevelButtonTextButton1"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "表示しない",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLevelButtonTextButton2"] = {
      ["EN"] = "Short",
      ["DE"] = "Kompakt",
      ["FR"] = "Short",
      ["ES"] = "Short",
      ["RU"] = "Short",
      ["KR"] = "짧게",
      ["JP"] = "短く",
      ["TW"] = "簡短"
   },
   ["GridCliqueIt_ConfigPageNamesCheckLevelButtonTextButton3"] = {
      ["EN"] = "Full",
      ["DE"] = "Vollst\195\164ndig",
      ["FR"] = "Full",
      ["ES"] = "Full",
      ["RU"] = "Full",
      ["KR"] = "길게",
      ["JP"] = "完全",
      ["TW"] = "完整"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckBarsButtonTextHead"] = {
      ["EN"] = "AddOn",
      ["DE"] = "AddOn",
      ["FR"] = "AddOn",
      ["ES"] = "AddOn",
      ["RU"] = "AddOn",
      ["KR"] = "애드온",
      ["JP"] = "アドオン",
      ["TW"] = "插件"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckBarsButtonTextButton1"] = {
      ["EN"] = "Enable",
      ["DE"] = "Aktivieren",
      ["FR"] = "Enable",
      ["ES"] = "Enable",
      ["RU"] = "Enable",
      ["KR"] = "활성",
      ["JP"] = "有効",
      ["TW"] = "啟用"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckBarsButtonTextButton2"] = {
      ["EN"] = "Disable",
      ["DE"] = "Deaktivieren",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
      ["KR"] = "비활성",
      ["JP"] = "無効",
      ["TW"] = "不啟用"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameColorButtonTextHead"] = {
      ["EN"] = "Unit Name Color Scheme",
      ["DE"] = "Farbschema der Spielernamen",
      ["FR"] = "Unit Name Color Scheme",
      ["ES"] = "Unit Name Color Scheme",
      ["RU"] = "Unit Name Color Scheme",
      ["KR"] = "캐릭터명 색상",
      ["JP"] = "職別カラー表示",
      ["TW"] = "單位名稱色彩配置"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameColorButtonTextButton1"] = {
      ["EN"] = "RoM",
      ["DE"] = "RoM",
      ["FR"] = "RoM",
      ["ES"] = "RoM",
      ["RU"] = "RoM",
      ["KR"] = "RoM",
      ["JP"] = "RoMスタイル",
      ["TW"] = "RoM"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameColorButtonTextButton2"] = {
      ["EN"] = "WoW",
      ["DE"] = "WoW",
      ["FR"] = "WoW",
      ["ES"] = "WoW",
      ["RU"] = "WoW",
      ["KR"] = "WoW",
      ["JP"] = "WoWスタイル",
      ["TW"] = "WoW"
   },
   ["GridCliqueIt_ConfigPageNamesCheckNameColorButtonTextButton3"] = {
      ["EN"] = "White",
      ["DE"] = "Wei\195\159",
      ["FR"] = "White",
      ["ES"] = "White",
      ["RU"] = "White",
      ["KR"] = "흰색",
      ["JP"] = "白",
      ["TW"] = "白"
   },
   ["GridCliqueIt_ConfigPageBarsCheckFillButtonTextHead"] = {
      ["EN"] = "Fill Bars From",
      ["DE"] = "Balken f\195\188llen von",
      ["FR"] = "Fill Bars From",
      ["ES"] = "Fill Bars From",
      ["RU"] = "Fill Bars From",
      ["KR"] = "바 채움 방식",
      ["JP"] = "HPバー染色",
      ["TW"] = "血條填滿形式"
   },
   ["GridCliqueIt_ConfigPageBarsCheckFillButtonTextButton1"] = {
      ["EN"] = "Left to Right",
      ["DE"] = "Links nach rechts",
      ["FR"] = "Left to Right",
      ["ES"] = "Left to Right",
      ["RU"] = "Left to Right",
      ["KR"] = "좌에서 우로",
      ["JP"] = "右へ染色",
      ["TW"] = "由左到右"
   },
   ["GridCliqueIt_ConfigPageBarsCheckFillButtonTextButton2"] = {
      ["EN"] = "Bottom to Top",
      ["DE"] = "Oben nach unten",
      ["FR"] = "Bottom to Top",
      ["ES"] = "Bottom to Top",
      ["RU"] = "Bottom to Top",
      ["KR"] = "아래에서 위로",
      ["JP"] = "上に染色",
      ["TW"] = "由下到上"
   },
   ["GridCliqueIt_ConfigPageBarsCheckAddMemberButtonTextHead"] = {
      ["EN"] = "Add New Group Members",
      ["DE"] = "Neue Gruppenmitglieder hinzuf\195\188gen",
      ["FR"] = "Add New Group Members",
      ["ES"] = "Add New Group Members",
      ["RU"] = "Add New Group Members",
      ["KR"] = "새로운 파티원 추가",
      ["JP"] = "メンバー表示",
      ["TW"] = "新增隊伍成員"
   },
   ["GridCliqueIt_ConfigPageBarsCheckAddMemberButtonTextButton1"] = {
      ["EN"] = "Horizontally",
      ["DE"] = "Horizontal",
      ["FR"] = "Horizontally",
      ["ES"] = "Horizontally",
      ["RU"] = "Horizontally",
      ["KR"] = "수평",
      ["JP"] = "横列",
      ["TW"] = "橫列"
   },
   ["GridCliqueIt_ConfigPageBarsCheckAddMemberButtonTextButton2"] = {
      ["EN"] = "Vertically",
      ["DE"] = "Vertikal",
      ["FR"] = "Vertically",
      ["ES"] = "Vertically",
      ["RU"] = "Vertically",
      ["KR"] = "수직",
      ["JP"] = "縦列",
      ["TW"] = "縱列"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckPerCharacterButtonTextHead"] = {
      ["EN"] = "Save Settings",
      ["DE"] = "Einstellungen speichern",
      ["FR"] = "Save Settings",
      ["ES"] = "Save Settings",
      ["RU"] = "Save Settings",
      ["KR"] = "설정 저장",
      ["JP"] = "設定保存",
      ["TW"] = "儲存設定"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckPerCharacterButtonTextButton1"] = {
      ["EN"] = "Per Character",
      ["DE"] = "Charakterspezifisch",
      ["FR"] = "Per Character",
      ["ES"] = "Per Character",
      ["RU"] = "Per Character",
      ["KR"] = "캐릭터별",
      ["JP"] = "キャラ別(推奨)",
      ["TW"] = "每個角色"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckPerCharacterButtonTextButton2"] = {
      ["EN"] = "Globally",
      ["DE"] = "Global",
      ["FR"] = "Globally",
      ["ES"] = "Globally",
      ["RU"] = "Globally",
      ["KR"] = "공용",
      ["JP"] = "全体共通",
      ["TW"] = "通用"
   },
 ["GridCliqueIt_ConfigPageGeneralCheckToolTipButtonTextHead"] = {
      ["EN"] = "ToolTip On:",
      ["DE"] = "ToolTip On:",
      ["FR"] = "ToolTip On:",
      ["ES"] = "ToolTip On:",
      ["RU"] = "ToolTip On:"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckToolTipButtonTextButton1"] = {
      ["EN"] = "Mouseover",
      ["DE"] = "Mouseover",
      ["FR"] = "Mouseover",
      ["ES"] = "Mouseover",
      ["RU"] = "Mouseover"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckToolTipButtonTextButton2"] = {
      ["EN"] = "Alt + Mouse",
      ["DE"] = "Alt + Mouse",
      ["FR"] = "Alt + Mouse",
      ["ES"] = "Alt + Mouse",
      ["RU"] = "Alt + Mouse"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckToolTipButtonTextButton3"] = {
      ["EN"] = "Never",
      ["DE"] = "Never",
      ["FR"] = "Never",
      ["ES"] = "Never",
      ["RU"] = "Never"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckSoloButtonTextHead"] = {
      ["EN"] = "When Solo",
      ["DE"] = "Au\195\159erhalb von Gruppen",
      ["FR"] = "When Solo",
      ["ES"] = "When Solo",
      ["RU"] = "When Solo",
      ["KR"] = "솔로 플레이 중",
      ["JP"] = "ソロ時",
      ["TW"] = "當不在隊伍中時"
   },
 ["GridCliqueIt_ConfigPageGeneralCheckPetsButtonTextHead"] = {
      ["EN"] = "Pets",
      ["DE"] = "Begleiter",
      ["FR"] = "Pets",
      ["ES"] = "Pets",
      ["RU"] = "Pets",
      ["KR"] = "소환수",
      ["JP"] = "ペット"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckPetsButtonTextButton1"] = {
      ["EN"] = "Show",
      ["DE"] = "Anzeigen",
      ["FR"] = "Show",
      ["ES"] = "Show",
      ["RU"] = "Show",
      ["KR"] = "표시",
      ["JP"] = "表示"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckPetsButtonTextButton2"] = {
      ["EN"] = "Hide",
      ["DE"] = "Verbergen",
      ["FR"] = "Hide",
      ["ES"] = "Hide",
      ["RU"] = "Hide",
      ["KR"] = "숨김",
      ["JP"] = "隠す"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckSoloButtonTextButton1"] = {
      ["EN"] = "Show",
      ["DE"] = "Anzeigen",
      ["FR"] = "Show",
      ["ES"] = "Show",
      ["RU"] = "Show",
      ["KR"] = "표시",
      ["JP"] = "表示",
      ["TW"] = "顯示"
   },
   ["GridCliqueIt_ConfigPageGeneralCheckSoloButtonTextButton2"] = {
      ["EN"] = "Hide",
      ["DE"] = "Verbergen",
      ["FR"] = "Hide",
      ["ES"] = "Hide",
      ["RU"] = "Hide",
      ["KR"] = "숨김",
      ["JP"] = "隠す",
      ["TW"] = "隱藏"
   },
   ["GridCliqueIt_ConfigPageGeneralEditPetScale"] = {
      ["EN"] = "Scale Pet Frames (in %)",
      ["DE"] = "Scale Pet Frames (in %)",
      ["FR"] = "Scale Pet Frames (in %)",
      ["ES"] = "Scale Pet Frames (in %)",
      ["RU"] = "Scale Pet Frames (in %)",
   },
   ["GridCliqueIt_ConfigPageGeneralEditAScale"] = {
      ["EN"] = "Scale Addon (in %)",
      ["DE"] = "AddOn-Skalierung (in %)",
      ["FR"] = "Scale Addon (in %)",
      ["ES"] = "Scale Addon (in %)",
      ["RU"] = "Scale Addon (in %)",
      ["KR"] = "애드온 크기(%)",
      ["JP"] = "アドオンのサイズ (in %)",
      ["TW"] = "調整插件尺寸(依 %)"
   },
   ["GridCliqueIt_ConfigPageGeneralEditAlpha"] = {
      ["EN"] = "Addon Alpha (in %)",
      ["DE"] = "AddOn-Alphawert (in %)",
      ["FR"] = "Addon Alpha (in %)",
      ["ES"] = "Addon Alpha (in %)",
      ["RU"] = "Addon Alpha (in %)",
      ["KR"] = "애드온 투명도(%)",
      ["JP"] = "アドオン透過率 (in %)",
      ["TW"] = "Addon Alpha (in %)"
   },
   ["GridCliqueIt_ConfigPageBarsEditMana"] = {
      ["EN"] = "Manabar Thickness (0 = disable)",
      ["DE"] = "Manabar Thickness (0 = disable)",
      ["FR"] = "Manabar Thickness (0 = disable)",
      ["ES"] = "Manabar Thickness (0 = disable)",
      ["RU"] = "Manabar Thickness (0 = disable)",
      ["KR"] = "MP 바 크기 (0 = 사용안함)",
      ["JP"] = "マナバー占有率 (0 = 無効)",
      ["TW"] = "Manabar Thickness (0 = disable)"
   },
   ["GridCliqueIt_ConfigPageGeneralEditIcon"] = {
      ["EN"] = "Debuff Icon Size (0 = disable)",
      ["DE"] = "Debuff Icon Size (0 = disable)",
      ["FR"] = "Debuff Icon Size (0 = disable)",
      ["ES"] = "Debuff Icon Size (0 = disable)",
      ["RU"] = "Debuff Icon Size (0 = disable)",
      ["KR"] = "디버프 아이콘 크기 (0 = 사용안함)",
      ["JP"] = "デバフアイコンサイズ (0 = 無効)",
      ["TW"] = "Debuff Icon Size (0 = disable)"
   },
   ["GridCliqueIt_ConfigPageNamesEditNLength"] = {
      ["EN"] = "Maximum Length of Character Names",
      ["DE"] = "Maximale L\195\164nge von Spielernamen",
      ["FR"] = "Maximum Length of Character Names",
      ["ES"] = "Maximum Length of Character Names",
      ["RU"] = "Maximum Length of Character Names",
      ["KR"] = "표시할 최대 캐릭터명 글자수(한글 1글자는 2에 해당)",
      ["JP"] = "キャラクター名の長さ",
      ["TW"] = "角色名稱最大長度"
   },
   ["GridCliqueIt_ConfigPageNamesEditNSize"] = {
      ["EN"] = "Scale Name Fonts (in %)",
      ["DE"] = "Namensskalierung (in %)",
      ["FR"] = "Scale Name Fonts (in %)",
      ["ES"] = "Scale Name Fonts (in %)",
      ["RU"] = "Scale Name Fonts (in %)",
      ["KR"] = "캐릭터명 글자 크기 (%)",
      ["JP"] = "名前のフォントサイズ (in %)",
      ["TW"] = "調整名稱字體尺寸 (依 %)"
   },
   ["GridCliqueIt_ConfigPageTextsEditDScale"] = {
      ["EN"] = "Scale of Deficit Font (in %)",
      ["DE"] = "Verlustanzeigenskalierung (in %)",
      ["FR"] = "Scale of Deficit Font (in %)",
      ["ES"] = "Scale of Deficit Font (in %)",
      ["RU"] = "Scale of Deficit Font (in %)",
      ["KR"] = "감소한 HP 글자 크기 (%)",
      ["JP"] = "被ダメ表示フォントサイズ (in %)",
      ["TW"] = "調整減損文字字體尺寸 (依 %)"
   },
   ["GridCliqueIt_ConfigPageTextsEditHScale"] = {
      ["EN"] = "Scale of HoT-timer Font (in %)" ,
      ["DE"] = "HoT-Timerskalierung (in %)" ,
      ["FR"] = "Scale of HoT-timer Font (in %)" ,
      ["ES"] = "Scale of HoT-timer Font (in %)" ,
      ["RU"] = "Scale of HoT-timer Font (in %)" ,
      ["KR"] = "도트힐 글자 크기 (%)" ,
      ["JP"] = "HoTタイマーのフォントサイズ (in %)",
      ["TW"] = "調整Hot計時字體尺寸 (依 %)"
   },
   ["GridCliqueIt_ConfigPageBarsEditX"] = {
      ["EN"] = "Bar Width",
      ["DE"] = "Balkenbreite",
      ["FR"] = "Bar Width",
      ["ES"] = "Bar Width",
      ["RU"] = "Bar Width",
      ["KR"] = "바 너비",
      ["JP"] = "バーの幅",
      ["TW"] = "血條寬度"
   },
   ["GridCliqueIt_ConfigPageBarsEditY"] = {
      ["EN"] = "Bar Height",
      ["DE"] = "Balkenh\195\182he",
      ["FR"] = "Bar Height",
      ["ES"] = "Bar Height",
      ["RU"] = "Bar Height",
      ["KR"] = "바 높이",
      ["JP"] = "バーの高さ",
      ["TW"] = "血條高度"
   },
   ["GridCliqueIt_ConfigPageBarsEditSpacing"] = {
      ["EN"] = "Spacing",
      ["DE"] = "Abstand",
      ["FR"] = "Spacing",
      ["ES"] = "Spacing",
      ["RU"] = "Spacing",
      ["KR"] = "간격",
      ["JP"] = "バーの間隔",
      ["TW"] = "間隔"
   },
   ["GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButtonTextHead"] = {
      ["EN"] = "Manabar Player Only",
      ["DE"] = "Manabar Player Only",
      ["FR"] = "Manabar Player Only",
      ["ES"] = "Manabar Player Only",
      ["RU"] = "Manabar Player Only",
   },
   ["GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButtonTextButton1"] = {
      ["EN"] = "Enable",
      ["DE"] = "Enable",
      ["FR"] = "Enable",
      ["ES"] = "Enable",
      ["RU"] = "Enable",
   },
   ["GridCliqueIt_ConfigPageBarsCheckManaOnlyPlayerButtonTextButton2"] = {
      ["EN"] = "Disable",
      ["DE"] = "Disable",
      ["FR"] = "Disable",
      ["ES"] = "Disable",
      ["RU"] = "Disable",
   },
   ["GridCliqueIt_ConfigButtonGeneral"] = {
      ["EN"] = "General",
      ["DE"] = "General",
      ["FR"] = "General",
      ["ES"] = "General",
      ["RU"] = "General",
      ["KR"] = "일반",
      ["JP"] = "一般",
   },
   ["GridCliqueIt_ConfigButtonSpells"] = {
      ["EN"] = "Spells",
      ["DE"] = "Spells",
      ["FR"] = "Spells",
      ["ES"] = "Spells",
      ["RU"] = "Spells",
      ["KR"] = "스킬",
      ["JP"] = "スペル",
   },
   ["GridCliqueIt_ConfigButtonNames"] = {
      ["EN"] = "Names",
      ["DE"] = "Names",
      ["FR"] = "Names",
      ["ES"] = "Names",
      ["RU"] = "Names",
      ["KR"] = "이름",
      ["JP"] = "名前",
   },
   ["GridCliqueIt_ConfigButtonTexts"] = {
      ["EN"] = "Texts",
      ["DE"] = "Texts",
      ["FR"] = "Texts",
      ["ES"] = "Texts",
      ["RU"] = "Texts",
      ["KR"] = "글자",
      ["JP"] = "テキスト",
   },
   ["GridCliqueIt_ConfigButtonBars"] = {
      ["EN"] = "Bars",
      ["DE"] = "Bars",
      ["FR"] = "Bars",
      ["ES"] = "Bars",
      ["RU"] = "Bars",
      ["KR"] = "바",
      ["JP"] = "バー",
   },
   ["GridCliqueIt_ConfigButtonSave"] = {
      ["EN"] = "Save",
      ["DE"] = "Save",
      ["FR"] = "Save",
      ["ES"] = "Save",
      ["RU"] = "Save",
      ["KR"] = "저장",
      ["JP"] = "保存",
   },
   ["GridCliqueIt_ConfigButtonCancel"] = {
      ["EN"] = "Cancel",
      ["DE"] = "Cancel",
      ["FR"] = "Cancel",
      ["ES"] = "Cancel",
      ["RU"] = "Cancel",
      ["KR"] = "취소",
      ["JP"] = "キャンセル",
   },
   ["GridCliqueIt_Anchor_MoveTitle_Move"] = {
      ["EN"] = "move",
      ["DE"] = "move",
      ["FR"] = "move",
      ["ES"] = "move",
      ["RU"] = "move",
      ["KR"] = "이동",
      ["JP"] = "移動",
   },
}

SpellTranslation = {
   ["Regenerate"] = {
      ["EN"] = "Regenerate",
      ["DE"] = "Regenerieren",
      ["FR"] = "Régénération",
      ["ES"] = "Regeneración",
      ["RU"] = "Регенерация",
      ["KR"] = "수호 마법",
      ["JP"] = "リジェネレーション",
      ["TW"] = "護佑之術"
   },
   ["Recover"] = {
      ["EN"] = "Recover",
      ["DE"] = "Erholung",
      ["FR"] = "Récupération",
      ["ES"] = "Recuperación",
      ["RU"] = "Восстановление",
      ["KR"] = "상처 치유",
      ["JP"] = "リカバー",
      ["TW"] = "Recover"
   },
   ["Blossoming Life Spell"] = {
      ["EN"] = "Blossoming Life",
      ["DE"] = "Blühendes Leben",
      ["FR"] = "Bourgeonnement de vie",
      ["ES"] = "Florecer de la Vida",
      ["RU"] = "Освободить жизнь",
      ["KR"] = "생명의 개화",
      ["JP"] = "ライフブロッサム",
      ["TW"] = "Blossoming Life"
   },
   ["Blossoming Life HoT"] = {
      ["EN"] = "Blossoming Life",
      ["DE"] = "Blühendes Leben",
      ["FR"] = "Vie fleuri",
      ["ES"] = "Florecer de la Vida",
      ["RU"] = "Освободить жизнь",
      ["KR"] = "생명의 개화",
      ["JP"] = "ライフブロッサム",
      ["TW"] = "Blossoming Life"
   },
   ["Healing Salve"] = {
      ["EN"] = "Healing Salve",
      ["DE"] = "Salbe",
      ["FR"] = "Salve curative",
      ["ES"] = "Bálsamo curativo",
      ["RU"] = "Лечебная мазь",
      ["KR"] = "위안",
      ["JP"] = "ヒールブースト",
      ["TW"] = "滋潤"
   },
   ["Wave Armor"] = {
      ["EN"] = "Wave Armor",
      ["DE"] = "Wellenpanzer",
      ["FR"] = "Armure aqueuse",
      ["ES"] = "Armadura reverberante",
      ["RU"] = "Волновая броня",
      ["KR"] = "보호의 물결갑옷",
      ["JP"] = "ウェーブレットアーマー",
      ["TW"] = "漣漪護甲"
   },
   ["Wave Armor Ineffective"] = {
      ["EN"] = "Wave Armor Ineffective",
      ["DE"] = "Wellenpanzer - Unwirksam",
      ["FR"] = "Armure de vague inefficace",
      ["ES"] = "Invulnerabilidad a Armadura reverberante",
      ["RU"] = "Волновая броня не действует",
      ["KR"] = "보호의 물결갑옷 무력화",
      ["JP"] = "ウェーブレットアーマー",
      ["TW"] = "漣漪護甲無效"
   },
   ["Restore Life"] = {
      ["EN"] = "Restore Life",
      ["DE"] = "Leben wiederherstellen",
      ["FR"] = "Rétablissement",
      ["ES"] = "Restaurar Vida",
      ["RU"] = "Восстановить жизнь",
      ["KR"] = "생명회복",
      ["JP"] = "ライフリストア",
      ["TW"] = "Restore Life"
   },
  ["Curing Seed"] = {
      ["EN"] = "Curing Seed",
      ["DE"] = "Samen der Heilung",
      ["FR"] = "Graine curative",
      ["ES"] = "Semilla Curativa",
      ["RU"] = "Целебное семя",
      ["KR"] = "치유의 씨앗",
      ["JP"] = "キュアシード",
      ["TW"] = "Curing Seed"
   },
  ["Mother Earth's Protection"] = {
      ["EN"] = "Mother Earth's Protection",
      ["DE"] = "Schutz von Mutter Erde",
      ["FR"] = "Protection de la Terre Mère",
      ["ES"] = "Protección de la Madre Tierra",
      ["RU"] = "Защита Земли",
      ["KR"] = "대지의 보호막",
      ["JP"] = "アースプロテクション",
      ["TW"] = "Mother Earth's Protection"
   },
  ["Camellia Flower"] = {
      ["EN"] = "Camellia Flower",
      ["DE"] = "Kamelienblüte",
      ["FR"] = "Fleur de camélia",
      ["ES"] = "Flor de Camelia",
   }
}


--[[Functions 
The job of the functions GridCliqueIt_HoTFound_?? is to find the two strings below, the job of the functions GridCliqueIt_HoTGetName_?? is to find out what $YOURNAME or $NAME is depending on whos beeing healed, it should also return how long the HoT is (20 for Regenerate and Blossoming Life, 14 for Recover).

The output to the combat log when healing is in most languages (so far only German is different) something like this:

CHANGED!

When healing yourself:
$YOURNAME text $SPELLNAME text $YOURNAME, $SPELLNAME $EFFECTIVE

When healing others:
$YOURNAME text $SPELLNAME $NAME text $NAME text $SPELLNAME

If the above strings are true for a specific language the following helper functions can be used:

GridCliqueIt_HoTFound(arg1)
-True if it finds your name first in arg1 and it has found two HoT spell names. Translates spells via the SpellTranslation list.

GridCliqueIt_HoTGetName(arg1, Effective, SearchString1, SearchString2, Add1, Add2)
-Looks for the string 'Effective' in 'arg1'. If found it returns your name. If not found it looks for the strings 'SearchString1' and 'SearchString2'. If it finds these it returns whats between 'SearchString1' + 'Add1' number of letters and 'SearchString2' + 'Add2' number of letters in 'arg1' (including 'SearchString1' + 'Add1' and 'SearchString2' + 'Add2' see the example below)

Example for english:

When healing yourself (if your character is named Tim) the combat logs says:
"Tim employs Regenerate on Tim, Regenerate effective"
so:
-GridCliqueIt_HoTFound(arg1) finds your name first and 2 regenerates so it returns true.
-GridCliqueIt_HoTGetName(arg1," effective", "-", " now", 2, -1) finds " effective" so your name (Tim) is returned. The heal was a regenerate so the time returned is 20.

When healing another player, here called "John", the combat log says:
"Tim casts Regenerate on John - John now benefits from the effects of Regenerate."
so:
-GridCliqueIt_HoTFound(arg1) finds your name first and 2 regenerates so it returns true.
-GridCliqueIt_HoTGetName(arg1," effective", "-", " now", 2, -1) does not find " effective" but it finds "-"  and " now" so it returns whats between "-" + 2 (first J in John) and " now" - 1 (last n in John) from arg1, i.e. it returns "John". The heal was a regenerate so the time returned is 20.
--]]


GetNameTranslation = {
   ["Effective"] = {
      ["EN"] = "You now benefit from the effects of your spell",
      ["DE"] = "Ihr genießt nun die Auswirkungen von Eurem Zauber",
      ["FR"] = "Vous bénéficiez à présent les effets de votre sort",
      ["ES"] = "Os beneficiáis de los efectos de vuestro hechizo",
      ["RU"] = " действует",
      ["KR"] = "시전하여 ",
      ["JP"] = " の効果",
      ["TW"] = "護佑之術"
   },
   ["SearchString1"] = {
      ["EN"] = "-",
      ["DE"] = "-",
      ["FR"] = "–",
      ["ES"] = "ahora ",
      ["RU"] =  "–",
      ["KR"] =  "시전하여,",
      ["JP"] = " は ",
      ["TW"] = "護佑之術"
   },
   ["SearchString2"] = {
      ["EN"] = " now",
      ["DE"] = "nun",
      ["FR"] = " bénéficie",
      ["ES"] =  " se",
      ["RU"] =  " пользуется",
      ["KR"] =  "은(는)",
      ["JP"] = " に",
      ["TW"] = "護佑之術"
   },
   ["Add1"] = {
      ["EN"] = 2,
      ["DE"] = 2,
      ["FR"] = 4,
      ["ES"] = 6,
      ["RU"] = 4,
      ["KR"] = 2,
      ["JP"] = 5,
      ["TW"] = "護佑之術"
   },
   ["Add2"] = {
      ["EN"] = -1,
      ["DE"] = -11,
      ["FR"] = -1,
      ["ES"] = -1,
      ["RU"] = -1,
      ["KR"] = -1,
      ["JP"] = -1,
      ["TW"] = "護佑之術"
   }
}

